#ifndef __ATRI_H
#define __ATRI_H

enum TtType
{
  TtUnshaded,
  TtFlatShaded,
  TtTextureMapped
};

class AstObjectDefinition;

struct AstTriangle
{
  int             vertices[3];
  AstScreenVertex texture_vertices[3];
  int             color;
  TtType          type;
  AstTextureMap  *map;

  AstFixedpoint_t plane_constant;
  AstVector       surface_normal;

  void ComputePlaneConstant( const AstObjectDefinition &odef );

  AstTriangle()
  {
     vertices[0] = 0;
     vertices[1] = 0;
     vertices[2] = 0;
     color = 0;
     type = TtUnshaded;
     map = 0;
     plane_constant = 0;
     surface_normal.X = surface_normal.Y = surface_normal.Z = 0;
  }
};

#endif
