#include "ast3d.h"

const int MOUSE_INTERRUPT = 0x33;

/*
** bool AstMouse::ResetDriver( void )
**
** This resets the mouse driver.  The value returned is "true"
** if the mouse driver is present and the mouse could be reset.
*/
bool AstMouse::ResetDriver( void ) const
{
REGS regs;


   REGISTERWORD( regs, ax ) = 0x21;
   INT86( MOUSE_INTERRUPT, &regs, &regs );

   return ( REGISTERWORD( regs, ax ) == 0xFFFF );
}

/*
** void AstMouse::Update( void )
**
** Updates the mouse's internal state information.
**
*/
void AstMouse::Update( void )
{
REGS regs;
int  screenx, screeny;

   /*
   ** Read buttons
   */
   REGISTERWORD( regs, ax ) = 3;
   INT86( MOUSE_INTERRUPT, &regs, &regs );
   buttons = ( char ) REGISTERWORD( regs, bx );
   screenx = REGISTERWORD( regs, cx );
   screeny = REGISTERWORD( regs, dx );

   /*
   ** Normalize screen values from -1 to 1 in X and Y directions
   */
   screenx -= ( SCREEN_WIDTH - 1 );
   x = AstFixDivFix( AstConvertToFix( screenx ), AstConvertToFix( SCREEN_WIDTH - 1 ) );

   y = AstFixDivFix( AstConvertToFix( screeny ), AstConvertToFix( SCREEN_HEIGHT - 1 ) );
   y -= AstConvertToFix( .5 );
   y *= 2;
}

